<?php

/********************************************************************************************************************
 * CoMoS - Comfort Monitoring Station
 * 
 * written by Mathias Kimmling, Konrad Lauenroth, Prof. Dr.-Ing Sabine Hoffmann
 * Department of the Built Environment
 * Technische Universität Kaiserslautern
 * 
 * This sketch is for CoMoS developed by the authors listed above.
 * Read more about the development and use cases of the Comfort Monitoring Station at
 * http://www.livinglab-smartofficespace.com/
 * http://www.livinglab-smartofficespace.com/en/research/heat-and-thermal-comfort/detail/pmv-sensor-stations/
 * And more about the authors' at
 * https://www.bauing.uni-kl.de/en/gst/home/
 * 
 * It is designed to run on ESP32 controllers with the following sensors:
 * Si7021 - temperature and humidity sensor
 * BH1750 - illuminance sensor
 * DS18B20+ - temperature sensor
 * Rev. C. - wind senser by Modern Device Co.
 * 
 * Wind speed calculation based on own calibration data.
 * Temperature and humidity calibration based on own calibration data.
 * 
 * MRT calculation based on DIN EN ISO 7726 standard.
 * 
 * License: CC-BY-NC-SA
 * All text above must be included in any redistribution. No commercial use without authors' approval. 
 ********************************************************************************************************************/


$mysql_host  = "localhost";			// database server IP (standard: localhost, if the database runs on the same device as this script)
$mysql_user  = "YourSQLUsername";	// SQL username
$mysql_pw    = "YourSQLPassword";	// SQL password
$mysql_db    = "sensorstation";		// database name (default: sensorstation)

// The following code is to check the address called by the sensor station for sensor readings included, and if so, store them in a $_variable.
// If any is not included, a blank '' will be used instead.
isset($_GET['ID']) ? $id=$_GET['ID'] : $id='';
isset($_GET['TEMP']) ? $temp=$_GET['TEMP'] : $temp='';
isset($_GET['HUM']) ? $hum=$_GET['HUM'] : $hum='';
isset($_GET['GLOBE']) ? $globe=$_GET['GLOBE'] : $globe='';
isset($_GET['VEL']) ? $vel=$_GET['VEL'] : $vel='';
isset($_GET['VELMIN']) ? $velmin=$_GET['VELMIN'] : $velmin='';
isset($_GET['VELMAX']) ? $velmax=$_GET['VELMAX'] : $velmax='';
isset($_GET['MRT']) ? $mrt=$_GET['MRT'] : $mrt='';
isset($_GET['ILLUM']) ? $illum=$_GET['ILLUM'] : $illum='';
isset($_GET['ILLUMMIN']) ? $illummin=$_GET['ILLUMMIN'] : $illummin='';
isset($_GET['ILLUMMAX']) ? $illummax=$_GET['ILLUMMAX'] : $illummax='';

$utcdate=gmdate('Y-m-d H:i:s',time());	// stores the current UTC timestamp to $utcdate variable

// The following code is to assign a static unique identifier to each ID.
// It can be used to assign a workplace number for each station for example.
// Can be skipped if not needed.
switch($id){
case 1: $uid='"Workplace_A"';break;
case 2: $uid='"Workplace_B"';break;
case 3: $uid='"Workplace_C"';break;
case 4: $uid='"Workplace_D"';break;
case 5: $uid='"Workplace_E"';break;
case 6: $uid='"Workplace_F"';break;
case 7: $uid='"Workplace_G"';break;
case 8: $uid='"Workplace_H"';break;
case 9: $uid='"Workplace_I"';break;
case 10:$uid='"Workplace_J"';break;
default:$uid='"0"';break;
}

// The following code is to write the received data to the SQL database.
// It also checks, if only zeros are received, to avoid writing zeros to database in case of an unintendet PHP call.
if($temp==0 && $hum==0 && $globe==0 && $vel==0 $illum==0){
	echo "";
}else{
$connection = mysqli_connect($mysql_host, $mysql_user, $mysql_pw) or die("Connection to SQL host failed.");     // connect to SQL host
mysqli_select_db($connection,$mysql_db) or die("Connection to SQL database failed.");							// connect to database
$insert_data = "INSERT INTO data (UTCDate,ID,UID,Temp,Hum,Globe,Vel,VelMin,VelMax,MRT,Illum,IllumMin,IllumMax) VALUES ('$utcdate',$id,$uid,$temp,$hum,$globe,$vel,$velmin,$velmax,$mrt,$illum,$illummin,$illummax)";  // create a query with the $ variables, which will write into "data" table
mysqli_query($connection,$insert_data) or die("Writing data to database failed.");  							// write the values from query into the database
mysqli_close($connection);																						// close connection to database
}
?>